﻿using C1.Chart;
using C1.Win.C1Input;
using C1.Win.Chart;
using C1.Win.FlexPivot;
using FlexPivot_Data;
using FlexPivot_Data.Model;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Globalization;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace FlexPivot_Demo
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            // fills country combobox with country names
            cbCountry.ItemsDataSource = new string[] { "World", "USA", "Brazil", "Russia", "Spain", "UK", "India", "Italy", "Peru", "Germany", "Iran", "Turkey", "France", "China"};

            cbCountry.SelectedItemChanged += CbCountry_SelectedItemChanged;
            cbCountry.SelectedIndex = 0;

            // prevents FlexPivot from showing totals row in FlexPivotGrid
            flexPivotPage.ShowTotalsRows =  C1.FlexPivot.ShowTotals.None;
            
            // sets FlexChart's color scheme
            flexPivotPage.Palette = Palette.Darkly;

            #region Define FlexPivotChart settings

            // sets FlexPivotChart type
            flexPivotPage.FlexPivotChart.ChartType = C1.Win.FlexPivot.ChartType.Column;

            // accesses new chart 'FlexChart' in FlexPivotPage
                        #endregion
        }
        #region Zooming
        Point _start, _last;
        bool _IsMouseDown;
        
        #endregion

        #region Selecting country for which to view Covid19 information in FlexPivot
        private void CbCountry_SelectedItemChanged(object sender, EventArgs e)
        {
            var countryCmb = sender as C1ComboBox;
            if (countryCmb != null && countryCmb.SelectedItem.ToString() != string.Empty)
            {
                ChangeDataSource(countryCmb.SelectedItem.ToString());
            }
        }
        #endregion
       

        

        #region DataSource
        public void ChangeDataSource(string countryName)
        {
            var data = DataLoader.Import(countryName).OrderBy(p=>p.Date).ToList();
            flexPivotPage.FlexPivotEngine.BeginUpdate();
            flexPivotPage.DataSource = data;
            flexPivotPage.FlexPivotEngine.RowFields.Add("Date");
            flexPivotPage.FlexPivotEngine.ValueFields.Add("TotalCases");
            flexPivotPage.FlexPivotEngine.ValueFields.Add("NewCases");
            flexPivotPage.FlexPivotEngine.ValueFields.Add("TotalDeaths");
            flexPivotPage.FlexPivotEngine.ValueFields.Add("NewDeaths");
            flexPivotPage.FlexPivotEngine.EndUpdate();

            if (countryName != "World")
                flexPivotPage.FlexPivotChart.ChartTitle = "Covid-19 Status for " + countryName;
            else
                flexPivotPage.FlexPivotChart.ChartTitle = "Covid-19 Status in World";

        }
        #endregion
    }
}
